SystemOrganization addCategory: #'CS528su13-Tiki'!

TestCase subclass: #TikiDatabaseTest
	instanceVariableNames: 'testdb testPage testSum'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiDatabaseTest methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/15/2013 22:24'!
setUp
	testdb := TikiNativeFileDatabase open: 'test_database'.
! !

!TikiDatabaseTest methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/16/2013 22:15'!
testCourseAccessing
	| course readback |
	course := (#(#tener #agreement) asOrderedCollection).
	testdb saveCourse: course as: 'testcourse'.
	readback := testdb loadCourse: 'testcourse'.
	self assert: course = readback! !

!TikiDatabaseTest methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/17/2013 22:44'!
testDatabaseServer
	| dbserver db1 db2 |
	dbserver := TikiDatabaseServer getInstance.
	db1 := dbserver connectToDB: 'test_database' type: TikiNativeFileDatabase.
	db2 := dbserver connectToDB: 'test_database' type: TikiNativeFileDatabase.
	self assert: db1 == db2! !

!TikiDatabaseTest methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/15/2013 22:25'!
testNewTag
	| tmp |
	tmp := (testdb loadRawPageFor: #notThere).
	self assert: tmp = nil! !

!TikiDatabaseTest methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/15/2013 22:00'!
testRawPageAccessing
	| tmp |
	testdb saveRawPage: 'line1' for: #intemediateResult.
	tmp := (testdb loadRawPageFor: #intemediateResult).
	self assert: tmp = 'line1'! !

!TikiDatabaseTest methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/16/2013 22:30'!
testRawSumAccessing
	| tmp |
	testdb saveRawSum: 'line1' for: #intemediateResult.
	tmp := (testdb loadRawSumFor: #intemediateResult).
	self assert: tmp = 'line1'! !

TestCase subclass: #TikiPoolTest
	instanceVariableNames: 'pagepool sumpool coursepool poolManager db'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiPoolTest methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/18/2013 01:03'!
setUp
	db := TikiNativeFileDatabase open: 'test_database'.
	poolManager := TikiContentPoolManager getInstance .
	poolManager clean.
	poolManager defaultCapacity: 1000.
	poolManager defaultAgingStrategy: TikiDefaultPageAgingStrategy .
	poolManager defaultDB: db.
	
	coursepool := poolManager connectToPool: 'course'
			loadFrom: [ :var1 :var2 | TikiCourse newCourseName: var1 tagList: (var2 loadCourse: var1) ].
	pagepool := poolManager connectToPool: 'page'
			loadFrom: [ :var1 :var2 | TikiPage newFrom: (var2  loadRawPageFor: var1) tag: var1 ].	
	sumpool := poolManager connectToPool: 'sum'
			loadFrom: [ :var1 :var2 | TikiSummary newTag: var1 text: (var2 loadRawSumFor: var1) ].! !

!TikiPoolTest methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/18/2013 01:02'!
testLoadCourse
	| item |
	item := coursepool findItem: #test_course.
	self assert: item data tagList = (#(#tener #agreement) asOrderedCollection)
	! !

!TikiPoolTest methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/18/2013 01:02'!
testLoadPage
	| item |

	item := pagepool findItem: #test_page.
	self assert: item data stringForEditting  = '#tenerque Tienes que #infinitives usar #agreement estos ejemplos.'
	! !

!TikiPoolTest methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/18/2013 01:03'!
testLoadSum
	| item |

	item := sumpool findItem: #testsum.
	self assert: item data text = 'An example of a sentence'
	! !

WAComponent subclass: #TikiCachedEntity
	instanceVariableNames: 'tag stats age data'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiCachedEntity commentStamp: '<historical>' prior: 0!
Instances are created when user's requesting a page and cached in TikiContentPool.

The instances keep TikiPage and TikiSummary in memory so they don't have to be read from database next time being used.

stats will be used for tag clound.
!

!TikiCachedEntity methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/17/2013 23:20'!
data
	^data! !

!TikiCachedEntity methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/17/2013 23:20'!
data: anObject
	data := anObject! !

!TikiCachedEntity methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/18/2013 23:29'!
renderContentOn: html
	html text: 'You just clicked on:'.
	html heading level3
	 	with: data tag asString.
	html text: (data text).! !

WAComponent subclass: #TikiWeb
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiWeb commentStamp: '<historical>' prior: 0!
A TikiWeb is container for the web controls.

Instance Variables
!

!TikiWeb methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/13/2013 02:38'!
style 
	^'.mainbox{ 
		margin-left:auto;
		margin-right:auto;
		width:60%;
		border:1px;
		background:#EDE;
	}
	.existingtag a:link {color:black; text-decoration:none}
	.existingtag a:visited{color:black; text-decoration:none}
	.existingtag a:hover { color:gray; text-decoration:none} 
	.existingtag a:active { color:black; text-decoration:none}
	
	.editcontrols { 
	border:solid 3px; background:#BBBBBB; 
	}
	.titletext { font-size:18px }
	#summarytext a:link {
		color:#66AA66; text-decoration:none
		}
	.newtag a:link {color:black; text-decoration:none}
	.newtag a:visited{color:black; text-decoration:none}
	.newtag a:hover{color:#FF2222; text-decoration:none}
	.newtag a:active { color:black; text-decoration:none}
	
	.nolink a:link {color:black; text-decoration:none}
	.nolink a:visited{color:black; text-decoration:none}
	.nolink a:hover{color:black; text-decoration:none}
	.nolink a:active { color:black; text-decoration:none}
		'! !

TikiWeb subclass: #TikiWebMain
	instanceVariableNames: 'allPages mainInput summaryInput currentPage editting makingnewpage expanded currentTag currentTOCPage currentCourse tempCourse allSummaries linkTag nativeDB pagepool sumpool coursepool'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiWebMain commentStamp: '<historical>' prior: 0!
A TikiWebMain is the main page for objects

Instance Variables
	allPages:		<Object>
	currentCourse:		<Object>
	currentPage:		<Object>
	currentTOCPage:		<Object>
	currentTag:		<Object>
	editting:		<Object>
	expanded:		<Object>
	mainInput:		<Object>
	makingnewpage:		<Object>
	summaryInput:		<Object>

allPages
	- xxxxx

currentCourse
	- xxxxx

currentPage
	- xxxxx

currentTOCPage
	- xxxxx

currentTag
	- xxxxx

editting
	- xxxxx

expanded
	- xxxxx

mainInput
	- xxxxx

makingnewpage
	- xxxxx

summaryInput
	- xxxxx
!

TikiWebMain subclass: #TikiWebControl
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiWebControl class methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/11/2013 22:12'!
canBeRoot
	^true! !

!TikiWebControl methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/11/2013 22:23'!
buildPage: html 
	super renderContentOn: html! !

!TikiWebControl methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/17/2013 22:47'!
initialize
	super initialize.
	editting:=false.
	mainInput:='Test input'.


! !

!TikiWebControl methodsFor: 'renderNav' stamp: 'PengLiu 7/11/2013 23:12'!
renderBackAnchor: html
	html listItem 
		with: 'Back'! !

!TikiWebControl methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/18/2013 22:59'!
renderContentOn: html
	html header
		with: [ self renderSiteBigLogo: html ].
	html navigation
		class: 'topnav';
		with: [ self renderNavMenu: html ].
	html div
		id: 'main';
		class: 'tikipage';
		with: [ super renderContentOn: html].
	html navigation
		class: 'topnav';
		with: [ self renderNavMenu: html ].
	html div
		id: 'popup';
		script: (html jQuery new dialog
     			title: '';
			position: 'right';
	     		autoOpen: false);
     		with: [ self renderDialogOn: html].
! !

!TikiWebControl methodsFor: 'renderPopup' stamp: 'PengLiu 7/12/2013 01:20'!
renderDialogOn: html
	html div class: 'box'; with: [
		html div
			id: #boxcontent;
			class: 'content';
			with: 'Brief explanation, cross references, all forum posts about this, etc' ]! !

!TikiWebControl methodsFor: 'renderNav' stamp: 'PengLiu 7/11/2013 23:12'!
renderForwordAnchor: html
	html listItem with: 'Forward'! !

!TikiWebControl methodsFor: 'renderNav' stamp: 'PengLiu 7/11/2013 23:13'!
renderNavMenu: html
	html unorderedList 
		class: 'navigation';
		with: [ self renderBackAnchor: html.
				self renderPrevLessonAnchor: html for: currentPage.
				self renderUpButton: html for: currentPage.
				self renderNextLessonAnchor: html for: currentPage.
				self renderForwordAnchor: html. ].
	html unorderedList 
		class: 'navigation';
		with: [ self renderSummaryButton: html for: currentPage ]! !

!TikiWebControl methodsFor: 'renderNav' stamp: 'PengLiu 7/11/2013 23:12'!
renderNextLessonAnchor: html for: aPage
	html listItem with: 'Next'! !

!TikiWebControl methodsFor: 'renderNav' stamp: 'PengLiu 7/11/2013 23:13'!
renderPrevLessonAnchor: html for: aPage
	html listItem with: 'Previous'! !

!TikiWebControl methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/11/2013 22:49'!
renderSiteBigLogo: html
	html heading 
		level1
		with: 'Tiki System Official Demo'! !

!TikiWebControl methodsFor: 'renderNav' stamp: 'PengLiu 7/12/2013 00:42'!
renderSummaryButton: html for: aPage
	html div
		id: 'tiki';
		with: [ 
			html listItem 
				with: [ 
					html anchor
						onClick: ((html jQuery id: 'popup') dialog
								open
								);
						onClick: (html jQuery ajax 
								script: [ :s | s << (s jQuery: #boxcontent) html: (self dialogContentFor: aPage tag) ]
						);		
						with: 'Summary'
					]
				]
! !

!TikiWebControl methodsFor: 'renderNav' stamp: 'PengLiu 7/11/2013 23:03'!
renderUpButton: html for: aPage
	html listItem with: 'Up'! !

!TikiWebControl methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/18/2013 23:02'!
style
	^ '
	header {
	   	border-bottom: 10px solid #74B46F;
    		margin: 0 auto;
    		text-align: center;
    		width: 100%;
	}
	header {
 	   	font-size: 1.5em;
	}
	header h1 {
    		margin-bottom: 0;
	}
	
	header h3 {
    		margin-bottom: 0.3em;
    		margin-top: 0;
	}
	
	div.box div.content{
		width: 100%;
	}
	div.box div.content{
    		border-color: #ff0000;
    		border-style: solid;
    		padding: 0 1em;
    		width: 12em;
	}
	div#main {
		min-height: 500px;
		margin: 30px auto;
		width: 100%;
    		border-color: #74B46F;
    		border-style: solid;
    		padding: 0 1em;
    		width: 58em;
	}

	div.content {
		margin: 30px auto;
		width: 100%;
	}
	
	div.content {
    		border-color: #74B46F;
    		border-style: solid;
    		padding: 0 1em;
    		width: 42em;
	}

	nav.topnav {
    		font-family: ''PT Sans'',sans-serif;
    		font-size: 1.2em;
    		margin: 15px 0;
    		text-align: center;
    		width: 100%;
	}
	nav.topnav ul.navigation {
    		list-style: none outside none;
    		margin: 0;
 	   	padding: 0;
	}
	nav.topnav ul.navigation li {
    		display: inline-block;
   		margin-left: 0.5em;
	}
	nav.topnav ul.navigation li a, nav.topnav ul.navigation li a:visited {
    		border-bottom: 5px solid #FFFFFF;
    		color: #3E914F;
    		line-height: 1em;
    		padding-bottom: 5px;
    		text-decoration: none;
	}
	nav.topnav ul.navigation li a:hover {
    		border-bottom: 5px solid #74B46F;
    		color: #1F4A28;
    		text-decoration: none;
	}
	
	nav.topnav ul.navigation li:first-child {
    		margin-left: 0 !!important;
	}
.mainbox{ 
		margin-left:auto;
		margin-right:auto;
		width:60%;
		border:1px;
		background:#EDE;
	}
	.existingtag a:link {color:black; text-decoration:none}
	.existingtag a:visited{color:black; text-decoration:none}
	.existingtag a:hover { color:gray; text-decoration:none} 
	.existingtag a:active { color:black; text-decoration:none}
	
	.editcontrols { 
	border:solid 3px; background:#BBBBBB; 
	}
	.titletext { font-size:18px }
	#summarytext a:link {
		color:#66AA66; text-decoration:none
		}
	.newtag a:link {color:black; text-decoration:none}
	.newtag a:visited{color:black; text-decoration:none}
	.newtag a:hover{color:#FF2222; text-decoration:none}
	.newtag a:active { color:black; text-decoration:none}
	
	.nolink a:link {color:black; text-decoration:none}
	.nolink a:visited{color:black; text-decoration:none}
	.nolink a:hover{color:black; text-decoration:none}
	.nolink a:active { color:black; text-decoration:none}
	'! !

!TikiWebMain class methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/1/2013 14:25'!
canBeRoot
^true! !

!TikiWebMain class methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/1/2013 14:48'!
initialize
	super initialize! !

!TikiWebMain methodsFor: 'accessing' stamp: 'NateOrlow 7/10/2013 16:25'!
allTags
^(allPages tagDictionaryKeys)! !

!TikiWebMain methodsFor: 'accessing' stamp: 'NateOrlow 7/11/2013 18:52'!
allTitles
^(allPages tagDictionaryKeys) do: [ :each| each asString ]! !

!TikiWebMain methodsFor: 'accessing' stamp: 'NateOrlow 7/11/2013 18:31'!
currentTOCPage
^currentTOCPage! !

!TikiWebMain methodsFor: 'accessing' stamp: 'NateOrlow 7/11/2013 19:37'!
currentTOCPage: anObject
currentTOCPage:=anObject! !

!TikiWebMain methodsFor: 'constants' stamp: 'NateOrlow 7/10/2013 17:24'!
defaultSummary
^'Input optional summary here'! !

!TikiWebMain methodsFor: 'accessing' stamp: 'PengLiu 7/18/2013 23:30'!
dialogContentFor: aSymbal
	| entity |
	entity := sumpool findItem: aSymbal .
	entity = nil ifFalse: [ ^entity ] ifTrue: [ ^TikiCachedEntity new data: (TikiSummary newTag: #notag text:'Tag not defined' ) ]! !

!TikiWebMain methodsFor: 'searching' stamp: 'NateOrlow 7/15/2013 15:12'!
findWithTag: aTag among: pagesDatabase
"you can just call this directly."
^ pagesDatabase findWithTag: aTag! !

!TikiWebMain methodsFor: 'initializing' stamp: 'PengLiu 7/18/2013 22:59'!
initialize
| poolManager |
super initialize.
self resetHomeOptions.

summaryInput:=self defaultSummary. "this is constant"
mainInput:='Test input'.

allPages := TikiPageDatabase new.
allPages initialize. "I don't see why this isn't being called 
automatically"
allSummaries:= TikiSummaryDatabase new.
allSummaries initialize.

self initializeSpanish.
currentCourse:=allPages allPagesCourse.

currentPage:= allPages getFirst.
currentTag:=currentPage tag.
currentTOCPage:= currentTag asString.

	nativeDB := TikiDatabaseServer getInstance connectToDB: 'test_database_rate' type: TikiNativeFileDatabase .
	poolManager := TikiContentPoolManager getInstance.
	poolManager clean.
	poolManager defaultCapacity: 1000.
	poolManager defaultAgingStrategy: TikiDefaultPageAgingStrategy .
	poolManager defaultDB: nativeDB.
	coursepool := poolManager connectToPool: 'course'
			loadFrom: [ :var1 :var2 | TikiCourse newCourseName: var1 tagList: (var2 loadCourse: var1) ].
	pagepool := poolManager connectToPool: 'page'
			loadFrom: [ :var1 :var2 | TikiPage newFrom: (var2  loadRawPageFor: var1) tag: var1 ].	
	sumpool := poolManager connectToPool: 'sum'
			loadFrom: [ :var1 :var2 | TikiSummary newTag: var1 text: (var2 loadRawSumFor: var1) ].
	currentPage := (pagepool findItem: #averagerate) data.
! !

!TikiWebMain methodsFor: 'initializing' stamp: 'NateOrlow 7/15/2013 16:19'!
initializeSpanish
"#tenerque Tienes que #infinitives usar #agreement estos ejemplos."
"THESE MUST STAY IN THE CURRENT ORDER FOR TAG DICTIONARY"

allPages add: (TikiPage newFrom:'#tenerque Tienes que #infinitives usar #agreement estos ejemplos.' tag: #main).
allSummaries add:(TikiSummary newTag: #main text: 'An example of a sentence').

allPages add: (TikiPage newFrom:'#nolink Tener que is an expression which means (have to). It is used by conjugating the verb #tener tener ' tag: #tenerque).
allSummaries add: (TikiSummary newTag: #tenerque text: 'Tener que means (have to)').

"#infinitives is missing to demonstrate creating a new page"
allPages add: (TikiPage newFrom:'#nolink Note that adjectives need to agree with the nouns they are modifying, so a masculine noun requires a masculine adjective or adverb.' tag:#agreement).
allSummaries add: (TikiSummary newTag: #agreement text:'The adjective/adverb must agree with the noun').

allPages add: (TikiPage newFrom:'#nolink Tener is the verb which means (to have) and is an irregular verb.' tag:#tener ).
allSummaries add: (TikiSummary newTag:#tener text: 'Tener means to have').

tempCourse:= TikiCourse newCourseName:'Temp course' tagList: (#(#tener #agreement) asOrderedCollection).! !

!TikiWebMain methodsFor: 'accessing' stamp: 'NateOrlow 7/1/2013 14:43'!
mainInput
^mainInput! !

!TikiWebMain methodsFor: 'accessing' stamp: 'NateOrlow 7/1/2013 14:54'!
mainInput: anInput
mainInput:=anInput! !

!TikiWebMain methodsFor: 'processing actions' stamp: 'NateOrlow 7/15/2013 16:38'!
makeNewPage
	(summaryInput = self defaultSummary) ifTrue:[summaryInput=''].
	allSummaries add: (TikiSummary newTag: linkTag text: summaryInput).
	allPages add: (TikiPage newFrom: mainInput tag: linkTag).
	self navigateToTag: linkTag.! !

!TikiWebMain methodsFor: 'navigating' stamp: 'NateOrlow 7/15/2013 16:09'!
navigateToTag:aSymbol
 	currentPage:=(self findWithTag: aSymbol among: allPages). "change the current page, not the summary"
	currentTag:=aSymbol.
	expanded:=''.! !

!TikiWebMain methodsFor: 'navigating' stamp: 'NateOrlow 7/15/2013 15:12'!
nextPage
currentPage:= self findWithTag: (currentCourse tagAfter: (currentPage tag)) among: allPages! !

!TikiWebMain methodsFor: 'navigating' stamp: 'NateOrlow 7/15/2013 15:12'!
previousPage
currentPage:= self findWithTag: (currentCourse tagBefore: (currentPage tag)) among: allPages! !

!TikiWebMain methodsFor: 'processing actions' stamp: 'NateOrlow 7/15/2013 16:09'!
processSummaryClick: aSymbol
self navigateToTag:aSymbol.! !

!TikiWebMain methodsFor: 'processing actions' stamp: 'NateOrlow 7/15/2013 16:21'!
processTagClick: aSymbol
		(aSymbol = #nolink) ifTrue: [^' (nolink was clicked)']. "this means nolink tags will not be processed"
	((self allTags) includes: aSymbol) ifFalse:[
		makingnewpage:=true.
		editting:=true.
		linkTag:=aSymbol.
	] ifTrue:[
		makingnewpage:=false.
		expanded=aSymbol ifTrue:[
			currentPage:=allPages findWithTag: aSymbol.
			expanded:=''
			] ifFalse:	[
			expanded:=aSymbol.
			]
		]! !

!TikiWebMain methodsFor: 'rendering' stamp: 'NateOrlow 7/15/2013 15:34'!
renderContentOn: html 
	"html heading: 'Version 10'.
	html break."
	html form:[
		html div
		class:'mainbox';
		with:[
			self renderCourses:html.
			html div
			class:'editcontrols';
			with:[
				editting ifTrue:[self renderEditting: html.
				] ifFalse:[
					(currentPage orderedLinks) do:[
						:each | self renderPageLink:html for: each
					].
				].
				html break.
				self renderEditCancelButtons: html.
			].	
			html break.
			self renderTOC: html.
		].	
	].	
	html break.
	html anchor
		callback: [ self processSummaryClick: #temp ];
		with: 'Test pop-up window'.! !

!TikiWebMain methodsFor: 'rendering' stamp: 'NateOrlow 7/13/2013 03:33'!
renderCourses: html
	html submitButton
		text:'Switch to temp course';
		callback: [ currentCourse:=tempCourse ].
	html submitButton
		text:'Switch to all pages';
		callback: [ currentCourse:=(allPages allPagesCourse)  ].
	"html text: (currentPage tag) asString."
! !

!TikiWebMain methodsFor: 'rendering' stamp: 'NateOrlow 7/15/2013 15:36'!
renderEditCancelButtons: html
	html submitButton 
	callback: [self submitEdit];
	text: (editting ifTrue: ['Submit page'] ifFalse: [ 'Start editting' ]).
	editting ifTrue:[
		html cancelButton
		callback:[editting:=false];
		text: ('Cancel edit').
	]! !

!TikiWebMain methodsFor: 'rendering' stamp: 'NateOrlow 7/15/2013 16:14'!
renderEditting: html
	makingnewpage ifTrue:[self renderEdittingNewPage: html].
	html textInput
	on: #summaryInput of: self.
	html break.
	html textInput
	on: #mainInput of: self
! !

!TikiWebMain methodsFor: 'rendering' stamp: 'NateOrlow 7/15/2013 16:15'!
renderEdittingNewPage: html
	html span
	class:'titletext';
	with:[ html text: 'Making new page: #',(linkTag asString)].
	html break.
! !

!TikiWebMain methodsFor: 'rendering' stamp: 'NateOrlow 7/15/2013 16:49'!
renderHomeButton: html
	html submitButton
		callback: [ self navigateToTag: currentCourse firstTag. self resetHomeOptions];
		text: 'Home screen'.
! !

!TikiWebMain methodsFor: 'rendering' stamp: 'NateOrlow 7/15/2013 15:12'!
renderPageLink: html for: each
	| tempAllTags |
	tempAllTags := self allTags.
	html span
	class: ((tempAllTags includes: each) 
		ifFalse: [ (each asSymbol = #nolink) ifTrue:['nolink'] ifFalse:['newtag']]
		ifTrue: [ 'existingtag' ]);
	with: [ 
		html anchor
		callback: [ self processTagClick: each asSymbol ];
		with: (currentPage linkDictionary at: each ifAbsent: [ '(' , each asString , ')' ]).

		html text: ' '.
		each = expanded ifTrue: [ 
			html span
			id: 'summarytext';
			with: [ 
				html anchor
				callback: [ self processSummaryClick: each asSymbol ];
				with: ' (' , ((self findWithTag: each asSymbol among:allSummaries) text), ') ' 
			]."end span with"
		html text: ' ' 
		]"end expanded with" 
	]"end span with"! !

!TikiWebMain methodsFor: 'rendering' stamp: 'NateOrlow 7/15/2013 16:11'!
renderTOC: html
	html break.
	html submitButton
		text: 'Previous page';
		callback: [self previousPage].
	
	self renderHomeButton: html.

	html submitButton
		text: 'Next page';
		callback: [self nextPage].
	html break.
	html select
		size:5;
		list: (currentCourse tagList);
		"list: (self allTitles);" "tag names are the easiest to use" 
		"though this allows support for titles in case we want to do that later on."
		selected: currentTag asString;
		callback: [:pageChosen|self navigateToTag: (pageChosen asSymbol)].
	html break.
	html submitButton 
		text:'View selected page'.
		"this just refreshes the screen"
! !

!TikiWebMain methodsFor: 'processing actions' stamp: 'NateOrlow 7/10/2013 18:40'!
resetHomeOptions
	expanded:=''.
	editting:=false.
	makingnewpage:=false.! !

!TikiWebMain methodsFor: 'processing actions' stamp: 'NateOrlow 7/15/2013 16:33'!
submitEdit
editting ifFalse:[
	editting:=true.
	mainInput:=(self findWithTag: currentTag among:allPages) stringForEditting.
	summaryInput:=(self findWithTag: currentTag among:allSummaries) text.
] ifTrue:[
	editting:=false.
	(mainInput beginsWith: '#') ifFalse:[mainInput:= '#nolink ',mainInput]. 
	makingnewpage ifTrue:[self makeNewPage] ifFalse:[
	(self findWithTag: currentTag among:allSummaries) text: summaryInput
	]. currentPage makeLinkDictionaryFrom: mainInput.
	expanded=''.
]! !

!TikiWebMain methodsFor: 'accessing' stamp: 'NateOrlow 7/10/2013 16:53'!
summaryInput
^summaryInput! !

!TikiWebMain methodsFor: 'accessing' stamp: 'NateOrlow 7/10/2013 16:53'!
summaryInput: anInput
summaryInput:=anInput! !

OrderedCollection subclass: #TikiDatabase
	instanceVariableNames: 'tagDictionary lastPageId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiDatabase commentStamp: '<historical>' prior: 0!
A TikiDatabase is the parent of TikiPageDatabase and TikiSummaryDatabase 

Instance Variables
!

!TikiDatabase methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 15:15'!
add: anObject
"public, use this to add pages to the database"
(lastPageId > 0) ifTrue: [super add: anObject afterIndex: lastPageId.] ifFalse: [super add: anObject].
self updateTagDictionaryWith: (anObject tag). 
self addMoreWith: anObject.
! !

!TikiDatabase methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 15:15'!
addMoreWith: anObject
"does nothing if there isn't more to add"! !

!TikiDatabase methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 14:53'!
findWithTag: aSymbol
"public"
( (tagDictionary keys) includes: aSymbol) ifTrue: [ ^ self at: (tagDictionary at: aSymbol)]  ifFalse: [^ self getFirst]! !

!TikiDatabase methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 14:51'!
getFirst
self assert: (self size) > 0. 
^(self at: 1)
! !

!TikiDatabase methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 15:10'!
initialize
	tagDictionary := Dictionary new.
	super initialize.	
	lastPageId:=0.! !

!TikiDatabase methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 14:46'!
tagDictionaryAt: aSymbol
^ (tagDictionary at: aSymbol)! !

!TikiDatabase methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 14:46'!
tagDictionaryKeys
^ (tagDictionary keys)! !

!TikiDatabase methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 14:59'!
updateTagDictionaryWith: aSymbol
"(This should be private?)"
lastPageId:=lastPageId+1.
tagDictionary at: aSymbol put: lastPageId! !

TikiDatabase subclass: #TikiPageDatabase
	instanceVariableNames: 'allPagesCourse'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiPageDatabase commentStamp: '<historical>' prior: 0!
A TikiPageDatabase is where pages are kept, with added messages for working with the pages.


Instance Variables
	lastPageId:		<Object>
	tagDictionary:		<Object>

lastPageId
	- xxxxx

tagDictionary
	- xxxxx
!

!TikiPageDatabase methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 15:09'!
addMoreWith: anObject
allPagesCourse add: (anObject tag).
! !

!TikiPageDatabase methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/13/2013 03:11'!
allPagesCourse
^allPagesCourse! !

!TikiPageDatabase methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 14:58'!
initialize
	super initialize.
	allPagesCourse := TikiCourse newCourseName: 'All pages' tagList: ((self tagDictionaryKeys) asOrderedCollection).! !

TikiDatabase subclass: #TikiSummaryDatabase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiSummaryDatabase commentStamp: '<historical>' prior: 0!
A TikiSummaryDatabase is a collection of TikiSummary objects, similar to TikiPageDatabase

Since TikiPageDatabase is already an ordered collection.

Instance Variables
!

Object subclass: #TikiAbstractDatabase
	instanceVariableNames: 'url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiAbstractDatabase commentStamp: '<historical>' prior: 0!
TikiAbstractDatabase acts as an interface for all other components which store contents into or load contents from disk.

Using tempelate pattern to move real job to subclasses.!

!TikiAbstractDatabase class methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/15/2013 21:32'!
open: url
	^(self new connect: url)! !

!TikiAbstractDatabase methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/14/2013 23:14'!
connect: aUrl 
	url := aUrl
	! !

!TikiAbstractDatabase methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/15/2013 23:07'!
loadCourse: courseName
	self subclassResponsibility ! !

!TikiAbstractDatabase methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/15/2013 21:26'!
loadRawPageFor: tag
	self subclassResponsibility ! !

!TikiAbstractDatabase methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/15/2013 21:29'!
loadRawSumFor: tag
	self subclassResponsibility ! !

!TikiAbstractDatabase methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/14/2013 23:23'!
removeTag: tag 
	self subclassResponsibility ! !

!TikiAbstractDatabase methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/15/2013 22:34'!
saveCourse: aCourse
	self subclassResponsibility ! !

!TikiAbstractDatabase methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/15/2013 23:07'!
saveCourse: aTagList as: courseName
	self subclassResponsibility ! !

!TikiAbstractDatabase methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/15/2013 21:15'!
savePage: aPage for: tag
	self saveRawPage: (aPage stringForEditting) for: tag! !

!TikiAbstractDatabase methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/15/2013 21:19'!
saveRawPage: aStrin  for: tag
	self subclassResponsibility ! !

!TikiAbstractDatabase methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/15/2013 21:19'!
saveRawSum: aString for: tag
	self subclassResponsibility ! !

!TikiAbstractDatabase methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/15/2013 21:17'!
saveSummary: summary for: tag
	self saveRawSum: (summary text) for: tag! !

TikiAbstractDatabase subclass: #TikiNativeFileDatabase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiNativeFileDatabase methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/18/2013 00:46'!
loadContentFor: tag with: ext
	| tmp output filename |
	filename := (url,'\',(tag asString),'.',ext).
	(StandardFileStream isAFileNamed: filename) ifFalse: [^nil].
	output 	:= WriteStream on: (String new: 10).
	tmp := StandardFileStream readOnlyFileNamed: filename.
	^tmp contentsOfEntireFile trim
"	[tmp atEnd]
		whileFalse:
			[ output nextPut: tmp next ].
	^output contents "! !

!TikiNativeFileDatabase methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/16/2013 22:13'!
loadCourse: courseName
	| taglist input line |
	taglist := OrderedCollection new.
	input := ReadStream on: (self loadContentFor: courseName with: 'course').
	line := input nextLine .
	[ line isNil  ]
		whileFalse: 	
			[ taglist add: line asSymbol. line:= input nextLine ].
	^taglist! !

!TikiNativeFileDatabase methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/15/2013 21:56'!
loadRawPageFor: tag
	^self loadContentFor: tag with: 'page'! !

!TikiNativeFileDatabase methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/18/2013 23:27'!
loadRawSumFor: tag
	^self loadContentFor: tag with: 'summary'! !

!TikiNativeFileDatabase methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/14/2013 23:25'!
removeTag: tag ! !

!TikiNativeFileDatabase methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/15/2013 21:56'!
saveContent: aString for: tag with: ext
	| tmp |
	tmp := StandardFileStream forceNewFileNamed: (url,'\',(tag asString),'.',ext).
	tmp nextPutAll: aString.
	tmp close! !

!TikiNativeFileDatabase methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/16/2013 22:13'!
saveCourse: aTagList as: courseName
	| output |
	output := WriteStream on: (String new:  10).
	aTagList do: [ :each | output nextPutAll: each asString. output cr ].
	self saveContent: (output contents) for: courseName with: 'course'
	
! !

!TikiNativeFileDatabase methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/15/2013 21:57'!
saveRawPage: aString  for: tag
	self saveContent: aString for: tag with: 'page'! !

!TikiNativeFileDatabase methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/18/2013 23:27'!
saveRawSum: aString for: tag
		self saveContent: aString for: tag with: 'summary'! !

Object subclass: #TikiContentPool
	instanceVariableNames: 'name sortedByAge preloadStrategy pageSema strategySema capacity agingStrategy pool loadBlock db'
	classVariableNames: 'inst'
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiContentPool commentStamp: '<historical>' prior: 0!
Singleton per Seaside server. It maintains a pool for TikiWebPage instances, so that TikiWebPage not being viewed by user can be cached here. 

If a TikiWebPage instance ages (decided with ageStrategy), it'll be removed from pool.

Some TikiWebPage instances may be preloaded according to preloadStrategy in order to be rendered faster. Potential preloadStrategy include to load next page of current one.!

!TikiContentPool class methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/17/2013 23:27'!
create: aString with: aBlock 
	| new |
	new := self new.
	new name: aString.
	new loadBlock: aBlock.
	^new! !

!TikiContentPool methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/17/2013 22:39'!
add: aPage withID: id
	"Add a page to pool. Remove old pages if pool size exceeds capacity
	This has to be called with pageSema held"
	| oldpages |
	pool at: id put: aPage.
	agingStrategy add: aPage withID: id.
	self itemCount > (self capacity ) ifTrue: [ 
				oldpages := agingStrategy retirePagesFrom: sortedByAge ]
			ifFalse: [ ^nil ].
	oldpages do: [ :each | pool removeKey: each ]
! !

!TikiContentPool methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/18/2013 00:13'!
ageStrategy: anAgeStrategy
	agingStrategy := anAgeStrategy 
! !

!TikiContentPool methodsFor: 'accessing' stamp: 'PengLiu 7/9/2013 22:22'!
capacity
	^capacity! !

!TikiContentPool methodsFor: 'accessing' stamp: 'PengLiu 7/9/2013 22:22'!
capacity: anInteger
	capacity := anInteger ! !

!TikiContentPool methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/17/2013 23:52'!
db
	^db! !

!TikiContentPool methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/17/2013 23:47'!
db: anTikiAbstractDatabase
	db := anTikiAbstractDatabase ! !

!TikiContentPool methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/18/2013 00:15'!
findItem: id
	| item  |
	item := pool at: id 
		ifAbsent: [ item := (self loadItem: id) ].
	item = nil ifTrue: [^nil].
	pool at: id put: (TikiCachedEntity new data: item).
	agingStrategy activate: id in: sortedByAge.
	^pool at: id! !

!TikiContentPool methodsFor: 'initialize-release' stamp: 'PengLiu 7/17/2013 22:39'!
initialize 
	pool := Dictionary new! !

!TikiContentPool methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/17/2013 22:39'!
itemCount
	^pool size! !

!TikiContentPool methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/17/2013 22:54'!
loadBlock: aBlock
	loadBlock := aBlock! !

!TikiContentPool methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/18/2013 00:01'!
loadItem: id
	| data |
	data := loadBlock value: id value: db .
	^data! !

!TikiContentPool methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/17/2013 22:53'!
name: aString
	name := aString! !

Object subclass: #TikiContentPoolManager
	instanceVariableNames: 'pools capacity aging db'
	classVariableNames: 'inst'
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiContentPoolManager commentStamp: '<historical>' prior: 0!
A server will have
 - one TikiContentPool instance for page caching
 - one TikiContentPool instance for summary caching
 - one TikiContentPool instance for course caching 

TikiContentPoolManager ensures above 3 are created by singleton pattern. TikiContentPoolManager also only has one instance on one Seaside server.!

!TikiContentPoolManager class methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/17/2013 22:22'!
getInstance
	inst = nil ifTrue: [ inst := self new ].
	^inst! !

!TikiContentPoolManager methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/18/2013 00:10'!
clean
	pools := Dictionary new! !

!TikiContentPoolManager methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/18/2013 00:12'!
connectToPool: aString loadFrom: aBlock
	| new |
	pools keysDo: [ :each | each = aString ifTrue: [ ^pools at: aString ] ].
	new := TikiContentPool create: aString with: aBlock.
	new capacity: capacity .
	new ageStrategy: aging.
	new db: db.
	pools at: aString put: new.
	^pools at: aString! !

!TikiContentPoolManager methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/17/2013 23:52'!
db
	^db! !

!TikiContentPoolManager methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/17/2013 23:12'!
defaultAgingStrategy: anClass 
	aging := anClass new! !

!TikiContentPoolManager methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/17/2013 23:09'!
defaultCapacity: anInteger
	capacity := anInteger ! !

!TikiContentPoolManager methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/17/2013 23:48'!
defaultDB: anTikiAbstractDatabase
	db := anTikiAbstractDatabase ! !

!TikiContentPoolManager methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/17/2013 22:43'!
initialize 
	pools := Dictionary new! !

Object subclass: #TikiCourse
	instanceVariableNames: 'courseName tagList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiCourse commentStamp: '<historical>' prior: 0!
A TikiCourse is a list of tags

Instance Variables
	courseName:		<Object>

courseName
	- xxxxx
!

!TikiCourse class methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/13/2013 03:15'!
newCourseName: aString tagList: anOC 
|tempCourse|
tempCourse:=TikiCourse new.
tempCourse courseName:aString tagList:anOC.
^tempCourse.! !

!TikiCourse methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/13/2013 02:57'!
add: aTag
tagList add: aTag! !

!TikiCourse methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/12/2013 19:20'!
courseName
^courseName! !

!TikiCourse methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/12/2013 19:20'!
courseName: aString
courseName:=aString.! !

!TikiCourse methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/13/2013 02:48'!
courseName: aString tagList: anOC 
courseName:=aString.
tagList:=anOC.! !

!TikiCourse methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/13/2013 03:29'!
firstTag
^(tagList at: 1)! !

!TikiCourse methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/13/2013 02:42'!
tagAfter:aTag
	|tempIndex|
	tempIndex:= tagList indexOf: aTag ifAbsent: 1.
	(tempIndex < tagList size) ifTrue: [ ^ tagList at: tempIndex+1 ].
	^ tagList at: tagList size! !

!TikiCourse methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/13/2013 02:43'!
tagBefore:aTag
	|tempIndex|
	tempIndex:= tagList indexOf: aTag ifAbsent: 1.
	tempIndex > 1 ifTrue: [ ^ tagList at: tempIndex-1 ].
	^ tagList at: 1! !

!TikiCourse methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/13/2013 03:21'!
tagList
^tagList! !

Object subclass: #TikiDatabaseServer
	instanceVariableNames: 'dbPool'
	classVariableNames: 'inst'
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiDatabaseServer commentStamp: '<historical>' prior: 0!
The system may have many TikiWeb instances. Some of them are accessing the same database for web page contents. Image all cs528 students reading the course website.

Usually database systems can support several requests simutaneous, so the server doesn't have to keep multiple TikiPageDatabase instances.

This class, TikiDataBaseServer, keeps one TikiPageDatabase instance per database URL. Itself has a singleton instance per seaside server.!

!TikiDatabaseServer class methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/8/2013 23:41'!
getInstance
	inst = nil ifTrue: [ inst := self new ].
	^inst! !

!TikiDatabaseServer methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/17/2013 22:27'!
connectToDB: aURL type: class
	dbPool keysDo: [ :each | each = aURL ifTrue: [ ^dbPool at: aURL ] ].
	dbPool at: aURL put: (class open: aURL).
	^ dbPool at: aURL! !

!TikiDatabaseServer methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/8/2013 23:42'!
initialize 
	dbPool := Dictionary new! !

Object subclass: #TikiPage
	instanceVariableNames: 'orderedLinks linkDictionary summary tag stringForEditting'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiPage commentStamp: '<historical>' prior: 0!
A TikiPage is an  indivisual page object, containing a tag and information, as well as a link dictionary.

Instance Variables
	linkDictionary:		<Object>
	orderedLinks:		<Object>
	summary:		<Object>
	tag:		<Object>

linkDictionary
	- xxxxx

orderedLinks
	- xxxxx

summary
	- xxxxx

tag
	- xxxxx
!

!TikiPage class methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/1/2013 18:38'!
newFrom:aString
|tempPage|
tempPage:=TikiPage new.
tempPage makeLinkDictionaryFrom:aString.
^tempPage! !

!TikiPage class methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 12:46'!
newFrom:aString tag: aTag
|tempPage|
tempPage:=TikiPage new.
tempPage tag:aTag.
tempPage makeLinkDictionaryFrom:aString.
^tempPage! !

!TikiPage class methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/8/2013 20:32'!
newFrom:aString tag: aTag summary: aSummary
|tempPage|
tempPage:=TikiPage new.
tempPage tag:aTag summary:aSummary.
tempPage makeLinkDictionaryFrom:aString.
^tempPage! !

!TikiPage methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 15:54'!
initialize 
linkDictionary:=Dictionary new.
orderedLinks:=OrderedCollection new.
summary:=''.
stringForEditting:=''.! !

!TikiPage methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/1/2013 18:33'!
linkDictionary
^linkDictionary! !

!TikiPage methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 15:54'!
makeLinkDictionaryFrom: aString 
|rawLinkList tempTag tempText tempLength tempIndex|
stringForEditting:=aString.

rawLinkList:=aString findTokens:$#.
"linkDictionary:= Dictionary new."
orderedLinks removeAll.
(linkDictionary keys) do: [ :each |  linkDictionary removeKey: each ].

rawLinkList do: [:each | tempLength:=each size. tempIndex:=each indexOf:(Character space). tempTag:=each copyFrom: 1 to: tempIndex-1. tempText:= each copyFrom: tempIndex+1 to:tempLength. orderedLinks add:tempTag. linkDictionary at: (tempTag asSymbol) put: tempText].
! !

!TikiPage methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/3/2013 12:29'!
orderedLinks
^orderedLinks! !

!TikiPage methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 15:54'!
stringForEditting
^stringForEditting! !

!TikiPage methodsFor: 'as yet unclassified' stamp: 'NateOrlow 6/1/2013 17:42'!
summary
^summary! !

!TikiPage methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/8/2013 20:29'!
tag
^tag! !

!TikiPage methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 12:45'!
tag: aSymbol
tag:=aSymbol.
! !

!TikiPage methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/8/2013 20:30'!
tag: aSymbol summary: aSummary
tag:=aSymbol.
summary:=aSummary.! !

Object subclass: #TikiPageAgingStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiPageAgingStrategy commentStamp: '<historical>' prior: 0!
Used by TikiWebPagePool!

TikiPageAgingStrategy subclass: #TikiDefaultPageAgingStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiDefaultPageAgingStrategy commentStamp: '<historical>' prior: 0!
Default strategy doesn't age and retire pages at all.!

!TikiPageAgingStrategy methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/9/2013 22:54'!
activate: page in: sortedCollection 
! !

!TikiPageAgingStrategy methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/9/2013 22:19'!
insert: aPage to: sortedByAge 
	"Insert aPage into a collection, sortedByAge. Subclasses can implement their own sortedByAge classes and override this method"
	! !

!TikiPageAgingStrategy methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/9/2013 22:53'!
retirePagesFrom: theSortedCollection
	! !

Object subclass: #TikiPagePreloadStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiPagePreloadStrategy commentStamp: '<historical>' prior: 0!
Used by TikiWebPagePool as the strategy to decide which pages should be preloaded to accelerate load time.!

!TikiPagePreloadStrategy methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/9/2013 22:14'!
computePageToBeLoad: aPage
	"given aPage, return an array with page ID's to be preloaded in itsuper "
	^#()! !

Object subclass: #TikiSummary
	instanceVariableNames: 'tag text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiSummary commentStamp: '<historical>' prior: 0!
A TikiSummary contains the content for summary -- basically what is clicked on when a link is explored.

Instance Variables
!

!TikiSummary class methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 14:17'!
newTag:aSymbol text:aString 
 |tempSummary|
tempSummary := TikiSummary new tag:aSymbol text: aString.
^tempSummary! !

!TikiSummary methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 11:49'!
tag
^tag! !

!TikiSummary methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 11:47'!
tag: aSymbol text: aString
tag:=aSymbol.
text:=aString.
! !

!TikiSummary methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 11:49'!
text
^text! !

!TikiSummary methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 15:59'!
text: aString
text:=aString.! !
TikiWebMain initialize!
